#!/usr/bin/env python

##dateconfig - Program creates a user interface 
##             that allows the system time, system date,
##             time zone, and ntpd configuration to be easily set
## Copyright (C) 2001 Red Hat, Inc.
## Copyright (C) 2001 Brent Fox <bfox@redhat.com>
##                    Tammy Fox <tfox@redhat.com>

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#Originally Written by Brent Fox
#Last Modified: May 25, 2001
#Created May 25, 2001

from gtk import *
from gnome.ui import *
from gnome.ui import GnomeCanvas
import GtkExtra
from GDK import *
import GdkImlib
import time
import sys
import mainWindow

##
## I18N
## 
import gettext
gettext.bindtextdomain ("dateconfig", "/usr/share/locale")
gettext.textdomain ("dateconfig")
_=gettext.gettext

try:
    sys.path.append('/usr/share/dateconfig/gnome-map')
    import timezonemap
except:
    sys.path.append('gnome-map')
    import timezonemap

class Map (GnomeCanvas):
    def __init__ (self, map):
        self._o = map

class List (GtkScrolledWindow):
    def __init__ (self, list):
        self._o = list

class Status (GtkStatusbar):
    def __init__ (self, bar):
        self._o = bar

class Option (GtkOptionMenu):
    def __init__ (self, option):
        self._o = option

class timezonePage (GtkVBox):
    def getTimezone (self):
        if self.utcCheck.get_active():
            self.asUTC = "true"
        else:
            self.asUTC = "false"
        return self.tz.getzone(self.list.get_text (self.list.selection[0], 0)), self.asUTC, self.asArc

    def setCurrentOnDraw (self, widget, *args):
        try:
            self.tz.setcurrent (self.default)
        except SystemError:
            pass
        widget.disconnect (self.id)

    def setCurrentOnShow (self, widget):
        try:
            self.tz.setcurrent (self.default)
        except:
            pass
    
    def __init__(self):
        GtkVBox.__init__(self, FALSE, 5)
        self.timezone = mainWindow.timezoneBackend.getTimezoneInfo()

        try:
            f = open ("/usr/share/dateconfig/gnome-map/pixmaps/map480.png")
            f.close ()
        except:
            path = "gnome-map/map480.png"
        else:
            path = "/usr/share/dateconfig/gnome-map/pixmaps/map480.png"
            
        tz = timezonemap.new(path)
        self.tz = tz
        map = Map (tz.map)
        swList = List (tz.citylist)
        self.list = swList.children ()[0]

	self.default, self.asUTC, self.asArc = self.timezone

        status = Status (tz.statusbar)
        views = Option (tz.views)

        self.id = self.list.connect ("draw", self.setCurrentOnDraw)
        self.list.connect ("show", self.setCurrentOnShow)

        self.utcCheck = GtkCheckButton(_("System clock uses UTC"))
        if self.asUTC == "true":
            self.utcCheck.set_active(TRUE)
        elif self.asUTC == "false":
            self.utcCheck.set_active(FALSE)
        
	# fix for current map weirdness in dr mike's code.
	views.get_menu ().children ()[0].activate ()

        label = GtkLabel (_("View:"))
        hbox = GtkHBox (FALSE, 5)
        hbox.pack_start (label, FALSE)
        align = GtkAlignment (0.5, 0.5)
        align.add (views)
        hbox.pack_start (align, FALSE)
        self.p1_align = align
        hbox.pack_start(self.utcCheck, FALSE)

        self.pack_start(hbox, FALSE)
        self.pack_start(map, FALSE)
        self.pack_start(status, FALSE)
        self.pack_start(swList, TRUE)
